#!/usr/bin/python
import subprocess
import re
import time

def getUsers():
    proc = subprocess.Popen(["momctl", "-q", "users"], stdout=subprocess.PIPE)
    users = []
    us = proc.stdout.readlines()[0].split()[-1][:-1].split(',')
    for u in us:
        users.append(u)
    return users

def getProcesses(activeu):
    pbs_mom = False
    proc = subprocess.Popen(["ps", "fax", "-eo" "user:20,stat,pid,command"], stdout=subprocess.PIPE)
    for line in proc.stdout.readlines():
        if re.search('pbs_mom -p', line):
            pbs_mom = True
            continue
        splitted = line.split()
        if pbs_mom:
            if re.search('\_ ', line) is None:
                pbs_mom = False
        if splitted[1] == 'D':
            ti = subprocess.Popen(["ps", "-o", "start", "-p", splitted[2]], stdout=subprocess.PIPE)
            for l in ti.stdout.readlines():
                continue
            if pbs_mom:
                if re.search(':', l) is None:
                    if splitted[0] in activeu:
                        print("Zasekle pod pbs_mom od: " + l.strip() + " pod active userom: " + splitted[0])
                    else:
                        print("Zasekle pod pbs_mom od: " + l.strip() + " pod inactive/system userom: " + splitted[0])
                    continue
            else:
                if re.search('\_ sync', line):
                    if splitted[0] in activeu:
                        print("Zasekly sync od: " + l.strip() + " pod active userom: " + splitted[0]
                    else:
                        print("Zasekly sync od: " + l.strip() + " pod inactive/system userom: " + splitted[0])
                        subprocess.call(["iptables", "-I", "OUTPUT", "-p", "tcp", "--dport", "2049", "-j", "REJECT"])
                        time.sleep(600)
                        subprocess.call(["iptables", "-D", "OUTPUT", "-p", "tcp", "--dport", "2049", "-j", "REJECT"])
                        break
                else:
                    if splitted[0] in activeu:
                        print("Zasekle urcite, neni nad tym pbs_mom od: " + l.strip() + " pod active userom: " + splitted[0] + " iptables sa nespusta lebo user je aktivny")
                    else:
                        print("Zasekle urcite, neni nad tym pbs_mom od: " + l.strip() + " pod inactive/system userom: " + splitted[0])
                        subprocess.call(["iptables", "-I", "OUTPUT", "-p", "tcp", "--dport", "2049", "-j", "REJECT"])
                        time.sleep(600)
                        subprocess.call(["iptables", "-D", "OUTPUT", "-p", "tcp", "--dport", "2049", "-j", "REJECT"])
                        break


if __name__ == "__main__":
    users = getUsers()
    getProcesses(users)
